package de.mdelab.mlsdm.interpreter.eclipse.searchModel;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.expressions.interpreter.core.ExpressionsInterpreterException;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.interpreter.MLSDMInterpreter;
import de.mdelab.mlsdm.interpreter.eclipse.MLSDMEclipseInterpreterFactory;
import de.mdelab.mlsdm.interpreter.eclipse.MLSDMEclipseMatcherFactory;
import de.mdelab.mlsdm.interpreter.notifications.MLSDMNotificationEmitter;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.SDMException;
import de.mdelab.sdm.interpreter.core.patternmatcher.StoryPatternMatcher;
import de.mdelab.sdm.interpreter.core.variables.NotifierVariablesScope;

public class MLSDMEclipseSearchModelFactory implements MLSDMEclipseInterpreterFactory , MLSDMEclipseMatcherFactory{

	@Override
	public MLSDMInterpreter createInterpreter(ClassLoader classLoader)
	throws SDMException {
		try {
			return new MLSDMEclipseSearchModelBasedInterpreter(classLoader);
		} catch ( final ExpressionsInterpreterException ex ) {
			throw new SDMException( ex );
		}
	}

	@Override
	public StoryPatternMatcher<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> createMatcher(
			StoryPattern storyPattern,
			NotifierVariablesScope<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> variablesScope,
			ClassLoader classLoader) 
	throws SDMException {
		try {
			return new MLSDMEclipseSearchModelBasedMatcher(storyPattern, variablesScope, classLoader, new MLSDMNotificationEmitter() );
		} catch ( final ExpressionsInterpreterException ex ) {
			throw new SDMException( ex );
		}
	}
}
