package de.mdelab.mlsdm.interpreter.facade;

import org.eclipse.emf.ecore.EClass;

import de.mdelab.mlcore.MLNamedElement;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.sdm.interpreter.core.facade.EActivityNodeType;
import de.mdelab.sdm.interpreter.core.facade.IActivityNodeFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public abstract class MLSDMActivityNodeFacade implements IActivityNodeFacade<ActivityNode>
{
	@Override
	public EActivityNodeType getActivityNodeType(final ActivityNode activityNode)
	{
		assert activityNode != null;

		final EClass activityNodeEClass = activityNode.eClass();

		if (activityNodeEClass == MlsdmPackage.Literals.STORY_NODE)
		{
			return EActivityNodeType.STORY_NODE;
		}
		else if (activityNodeEClass == MlsdmPackage.Literals.EXPRESSION_ACTIVITY_NODE)
		{
			return EActivityNodeType.STATEMENT_NODE;
		}
		else if (activityNodeEClass == MlsdmPackage.Literals.DECISION_MERGE_NODE)
		{
			return EActivityNodeType.DECISION_NODE;
		}
		else if (activityNodeEClass == MlsdmPackage.Literals.ACTIVITY_FINAL_NODE)
		{
			return EActivityNodeType.ACTIVITY_FINAL_NODE;
		}
		else if (activityNodeEClass == MlsdmPackage.Literals.INITIAL_NODE)
		{
			return EActivityNodeType.NON_EXECUTABLE_NODE;
		}
		else
		{
			throw new UnsupportedOperationException();
		}
	}

	@Override
	public String getName(final ActivityNode activityNode)
	{
		assert activityNode != null;

		if (activityNode instanceof MLNamedElement)
		{
			return ((MLNamedElement) activityNode).getName();
		}
		else
		{
			return null;
		}
	}
}
