package de.mdelab.mlsdm.interpreter.searchModel.model;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.MLSDMSearchModelBasedMatcher;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.CheckMatchingAction;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.PatternConstraint;

/**
 * This is a matching action implementation for the MLSDM meta model.
 * 
 * @author Matthias.Barkowsky
 *
 */
public abstract class MLSDMCheckMatchingAction extends CheckMatchingAction<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> {
	
	/*
	 * Search model based matcher possibly using this matching action.
	 */
	protected MLSDMSearchModelBasedMatcher matcher;
	
	public MLSDMCheckMatchingAction(int id, MLSDMSearchModelBasedMatcher matcher,
			PatternConstraint<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> patternConstraint) {
		super(id);
		this.matcher = matcher;
		this.patternConstraint = patternConstraint;
	}

	public MLSDMCheckMatchingAction(int id, MLSDMSearchModelBasedMatcher matcher) {
		this(id, matcher, null);
	}

}
